<?php

# LinkorCMS
#  2006-2010    (galitsky@pochta.ru)
# : tree.class.php
# :        

if(!defined('VALID_RUN')){
	Header("Location: http://".getenv("HTTP_HOST")."/index.php");
	exit();
}

define("TREE_CHILD_ID", 'child');
$FCatsData = array();

class Tree
{
	public $Table; //    .
	public $tree; //   .
	public $Cats; //  ,  
	//     .
	public $IdCats; //  ,  
	//      .
	public $data = array();
	public $childs = array();
	public $sel_id = 0;
	public $IdKey = 'id';
	public $ParentKey = 'parent_id';
	public $TitleKey = 'title';
	public $FileCounterKey = 'file_counter';
	public $CatCounterKey = 'cat_counter';

	//  
	public function Tree( $Table, $IdKey = 'id', $ParentKey = 'parent', $TitleKey = 'title', $FileCounterKey = 'file_counter', $CatCounterKey = 'cat_counter' )
	{
		global $db, $config;
		$this->IdKey = $IdKey;
		$this->ParentKey = $ParentKey;
		$this->TitleKey = $TitleKey;
		$this->FileCounterKey = $FileCounterKey;
		$this->CatCounterKey = $CatCounterKey;
		$cats = array();
		$cats2 = array();
		if(!is_array($Table)){
			$this->Table = $Table;
			$Table = $db->Select($Table);
		}
		foreach($Table as $cat){
			$cats[$cat[$ParentKey]][] = $cat;
			$cats2[$cat[$IdKey]] = $cat;
		}
		$this->Cats = $cats;
		$this->IdCats = $cats2;
	}

	//  
	public function NewTree( &$tree, $pid, $source, $fid )
	{
		//  
		if(isset($source[$pid])){
			//   
			for($i = 0, $c = count($source[$pid]); $i < $c; $i++){
				$ncat = $source[$pid][$i];
				$this->NewTree($ncat, $ncat[0], $source, $fid);
				if($pid == $fid){
					$tree[] = $ncat;
				}else{
					$tree[TREE_CHILD_ID][] = $ncat;
				}
			}
			return $tree;
		}else{
			return array();
		}
	}

	public function ToCatsTree( $tree, $level, $callbackFunc )
	{
		if(isset($tree[TREE_CHILD_ID])){
			for($i = 0, $c = count($tree[TREE_CHILD_ID]); $i < $c; $i++){
				call_user_func_array($callbackFunc, array($tree[TREE_CHILD_ID][$i], $level));
				$this->ToCatsTree($tree[TREE_CHILD_ID][$i], $level + 1, $callbackFunc);
			}
		}
	}

	public function GetIds( $tree, &$result )
	{
		if(isset($tree[TREE_CHILD_ID])){
			for($i = 0, $c = count($tree[TREE_CHILD_ID]); $i < $c; $i++){
				$result[] = $tree[TREE_CHILD_ID][$i][$this->IdKey];
				$this->GetIds($tree[TREE_CHILD_ID][$i], $result);
			}
		}
	}

	public function GetChildTree( $pid )
	{
		$tree = array();
		$this->NewTree($tree, $pid, $this->Cats, $pid);
		$this->tree = $tree;
		return $tree;
	}

	//     
	/*  
		function UserFunc($cat,$level){
		$cat -   
		$level -  
	*/
	public function ListingTree( $pid, $callbackFunc )
	{
		$this->GetChildTree($pid);
		if((!is_array($callbackFunc) && !@function_exists($callbackFunc)) || (is_array($callbackFunc) && !@method_exists($callbackFunc[0], $callbackFunc[1]))){
			error_handler(NOTICE, 'CallBack   .', 'Tree->ListingTree()');
			return false;
		}else{
			if(count($this->tree) == 0){
				return false;
			}
			for($i = 0, $c = count($this->tree); $i < $c; $i++){
				call_user_func_array($callbackFunc, array($this->tree[$i], 0));
				$this->ToCatsTree($this->tree[$i], 1, $callbackFunc);
			}
			return true;
		}
	}

	//      
	//       $pid.
	public function GetAllChildId( $pid )
	{
		$this->GetChildTree($pid);
		$result = array();
		$c = count($this->tree);
		if($c > 0){
			for($i = 0; $i < $c; $i++){
				$result[] = $this->tree[$i][$this->IdKey];
				$this->GetIds($this->tree[$i], $result);
			}
		}
		$result[] = $pid;
		return $result;
	}

	//    
	public function GetParentId( $curId )
	{
		global $db, $config;
		if(isset($this->IdCats[$curId])){
			return $this->IdCats[$curId][$this->ParentKey];
		}else{
			return 0;
		}
	}

	//   
	public function GetAllParent( $curId, $reverse = true )
	{
		global $db, $config;
		if(count($this->IdCats) > 0){
			$find = true;
			$result = array();
			$result2 = array();
			while($find){
				if(isset($this->IdCats[$curId])){
					$result[] = $this->IdCats[$curId];
					$curId = $this->IdCats[$curId][$this->ParentKey];
					$find = true;
				}else{
					$find = false;
				}
			}
			if($reverse){
				$c = count($result) - 1;
				for($i = $c; $i >= 0; $i--){
					$result2[] = $result[$i];
					unset($result[$i]);
				}
				$result = $result2;
			}
			return $result;
		}else{
			return false;
		}
	}

	//      
	//      
	public function CalcFileCounter( $id, $inc )
	{
		global $db, $config;
		$db->Select($this->Table, "`".$this->IdKey."`='$id'");
		if($db->NumRows() > 0){
			$cat = $db->FetchRow();
			if($inc == true){
				$counter_val = $cat[$this->FileCounterKey] + 1;
			}else{
				$counter_val = $cat[$this->FileCounterKey] - 1;
			}
			$db->Update($this->Table, $this->FileCounterKey."='$counter_val'", "`".$this->IdKey."`='$id'");
		}
	}

	//      
	//      
	public function CalcCatCounter( $id, $inc )
	{
		global $db, $config;
		$db->Select($this->Table, "`".$this->IdKey."`='$id'");
		if($db->NumRows() > 0){
			$cat = $db->FetchRow();
			if($inc == true){
				$counter_val = $cat[$this->CatCounterKey] + 1;
			}else{
				$counter_val = $cat[$this->CatCounterKey] - 1;
			}
			$db->Update($this->Table, $this->CatCounterKey."='$counter_val'", "`".$this->IdKey."`='$id'");
		}
	}

	public function CatsData( $tree, $level )
	{
		global $site, $FCatsData;
		if(in_array($tree[$this->IdKey], $this->childs) === false){
			$levs = str_repeat('&nbsp;-&nbsp;', $level);
			$site->DataAdd($FCatsData, $tree[$this->IdKey], $levs.$tree[$this->TitleKey].($this->viewitems && isset($tree[$this->FileCounterKey]) ? ' ('.$tree[$this->FileCounterKey].')' : ''), ($tree[$this->IdKey] == $this->sel_id));
		}
	}

	#        
	public function GetCatsData( $sel_id, $viewitems = false, $root = false, $id = 0, $xor = false )
	{
		global $site, $FCatsData;
		$this->childs = array();
		$this->sel_id = $sel_id;
		$this->viewitems = $viewitems;
		if($xor){
			$this->childs = $this->GetAllChildId($id);
		}
		if($root){
			$site->DataAdd($FCatsData, '0', ' /', $sel_id == 0);
		}
		$this->ListingTree(0, array($this, 'CatsData'));
		return $FCatsData;
	}
}

?>