<?php

if(!defined('VALID_RUN')){
	Header("Location: http://".getenv("HTTP_HOST")."/index.php");
	exit();
}

include_once ($config['inc_dir'].'tree_b.class.php');
$tree = new IndexTree('downloads_cats');
$tree->moduleName = 'downloads';
$tree->catTemplate = 'module/download_cat.html';
$tree->id_par_name = 'cat';
$tree->NumItemsCaption = '<center>    : ';
$tree->TopCatName = '';

function filetypecheck( $filename )
{
	$ext = substr(GetFileExt($filename), 1);
	if($ext == 'rar'){ $dtype = ' RAR'; }
	if($ext == 'zip'){ $dtype = ' ZIP'; }
	if($ext == '7z') { $dtype = ' 7zip'; }
	if($ext == 'bz2'){ $dtype = 'BZ2'; }
	if($ext == 'cab'){ $dtype = 'CAB'; }
	if($ext == 'ace'){ $dtype = 'WinACE'; }
	if($ext == 'arj'){ $dtype = '<a class=\"cont\" href=\"http://www.tsf.be/\" target=\"_blank\">ARJ</a>'; }
	if($ext == 'jar'){ $dtype = '<a class=\"cont\" href=\"http://www.tsf.be/\" target=\"_blank\">JAR</a>'; }

	if($ext == 'gzip'){ $dtype = 'GZIP'; }
	if($ext == 'tar'){ $dtype = 'TAR'; }
	if($ext == 'tgz'){ $dtype = 'TGZ'; }
	if($ext == 'gz'){ $dtype = 'GZ'; }

	if($ext == 'gif'){ $dtype = 'GIF'; }
	if(preg_match('/jpeg|jpe|jpg/i', $ext)){ $dtype = 'JPEG/JPE/JPG'; }
	if($ext == 'png'){ $dtype = 'PNG'; }
	if($ext == 'bmp'){ $dtype = 'BMP'; }

	if($ext == 'txt'){ $dtype = 'TXT'; }
	if($ext == 'sql'){ $dtype = 'SQL'; }
	if($ext == 'exe'){ $dtype = 'EXE'; }
	if($ext == 'swf'){ $dtype = 'SWF'; }
	if($ext == 'fla'){ $dtype = 'FLA'; }
	if(preg_match('/flv|f4v|f4p|f4a|f4b/i', $ext)){ $dtype = 'Flash Video (FLV)'; }

	if($ext == 'wav'){ $dtype = 'WAV'; }
	if($ext == 'mp2'){ $dtype = 'MP2'; }
	if($ext == 'mp3'){ $dtype = 'MP3'; }
	if($ext == 'mp4'){ $dtype = 'MP4'; }
	if(preg_match('/ogv|oga|ogx|ogg/i', $ext)){ $dtype = 'Ogg'; }
	if($ext == 'mid'){ $dtype = 'MID'; }
	if($ext == 'midi'){ $dtype = 'MIDI'; }
	if($ext == 'mmf'){ $dtype = 'MMF'; }

	if($ext == 'mpeg'){ $dtype = 'MPEG'; }
	if($ext == 'mpe'){ $dtype = 'MPE'; }
	if($ext == 'mpg'){ $dtype = 'MPG'; }
	if($ext == 'mpa'){ $dtype = 'MPA'; }
	if($ext == 'avi'){ $dtype = 'AVI'; }
	if($ext == 'mpga'){ $dtype = 'MPGA'; }

	if(preg_match('/pdf|pds/i', $ext)){ $dtype = ' Adobe PDF'; }
	if(preg_match('/xls|xl|xla|xlb|xlc|xld|xlk|xll|xlm|xlt|xlv|xlw/i', $ext)){ $dtype = ' MS-Excel'; }
	if(preg_match('/doc|dot|wiz|wzs|docx/i', $ext)){ $dtype = ' MS-Word'; }
	if($ext == 'odt'){ $dtype = '  OpenDocument'; }
	if($ext == 'odg'){ $dtype = '  OpenDocument'; }
	if($ext == 'odp'){ $dtype = '  OpenDocument'; }
	if($ext == 'ods'){ $dtype = '  OpenDocument'; }
	if($ext == 'odc'){ $dtype = '  OpenDocument'; }
	if($ext == 'odi'){ $dtype = '  OpenDocument'; }
	if($ext == 'odf'){ $dtype = '  OpenDocument'; }
	if($ext == 'odm'){ $dtype = '   OpenDocument'; }
	if(preg_match('/pot|ppa|pps|ppt|pwz/i', $ext)){ $dtype = ' MS-Powerpoint'; }
	if($ext == 'rtf'){ $dtype = 'RTF'; }
	if(empty($dtype)) $dtype = '';

	return $dtype;
}

function IndexDownloadsGetNumItems()
{
	global $db;
	$ex_where = GetWhereByAccess('view');
	$db->Select('downloads', "`active`='1'".($ex_where != '' ? ' and '.$ex_where : ''));
	return $db->NumRows().'.</center>';
}

function IndexDownloadsFunc($id)
{
	global $config;
	return
	'&nbsp'
	.'<a href="'.$config['admin_file'].'?exe=downloads&amp;a=editor&amp;id='.$id.'">'
	.'<img src="images/admin/edit.gif" title="">'
	.'</a>'
	.'<a href="'.$config['admin_file'].'?exe=downloads&amp;a=deletefile&amp;id='.$id.'&amp;ok=0">'
	.'<img src="images/admin/delete.gif" title="">'
	.'</a>';
}

function AddDownload(&$down)
{
	global $site, $config, $user;

	$id = SafeDB($down['id'], 11, int);
	$cat_id = SafeDB($down['category'], 11, int);
	$func = IndexDownloadsFunc($id);

	$vars = array();
	$vars['file_title'] = SafeDB($down['title'], 255, str).($user->isAdmin() ? $func : '');
	$vars['url'] = 'index.php?name=downloads&amp;op=full&amp;cat='.$cat_id.'&amp;file='.$id;

	if($down['image'] != ''){
		$vars['image'] = RealPath2($config['downloads']['images_dir'].SafeDB($down['image'], 255, str));
		$vars['thumb_image'] = RealPath2($config['downloads']['images_dir'].'thumbs/'.SafeDB($down['image'], 255, str));
	}else{
		$vars['image'] = false;
	}
	$vars['description'] = SafeDB($down['shortdesc'], 255, str, false, false);
	$vars['size'] = FormatFileSize(SafeDB($down['size'], 11, real), SafeDB($down['size_type'], 1, str));
	$vars['hits'] = SafeDB($down['hits'], 11, int);
	if($down['allow_comments'] == '1'){
		$vars['comments'] = SafeDB($down['comments_counter'], 11, int);
	}else{
		$vars['comments'] = ' - ';
	}
	$vars['rating'] = GetRatingImage(SafeDB($down['votes_amount'], 11, int),
									SafeDB($down['votes'], 11, int));
	$site->AddSubBlock('download', true, $vars);
}

function AddDetailDownload(&$down)
{
	global $site, $config, $tree, $user;

	$id = SafeDB($down['id'], 11, int);
	$cat_id = SafeDB($down['category'], 11, int);
	$func = IndexDownloadsFunc($id);

	$vars = array();
	$vars['category'] = '<a href="index.php?name=downloads&amp;cat='.$cat_id.'">'.$tree->IdCats[$down[1]][1].'</a>';
	if($user->AccessIsResolved($down['view'])){
		$url = '<a href="index.php?name=downloads&amp;op=download&amp;file='.$id.'" target="_blank"> </a>';
	}else{
		$url = '    .';
	}
	$vars['url'] = $url;

	$vars['file_title'] = SafeDB($down['title'], 255, str).($user->isAdmin() ? $func : '');
	$vars['description'] = SafeDB($down['description'], 0, str, false, false);

	$vars['author'] = SafeDB($down['author'], 200, str);
	$vars['homepage'] = SafeDB($down['author_site'], 250, str);
	$vars['homepage_url'] = UrlRender(SafeDB($down['author_site'], 250, str));
	$vars['mail'] = SafeDB($down['author_email'], 50, str);

	$vars['date'] = TimeRender($down['public']);
	$vars['hits'] = SafeDB($down['hits'], 11, int);
	$vars['version'] = SafeDB($down['file_version'], 250, str);

	$vars['size'] = FormatFileSize(SafeDB($down['size'], 11, real), SafeDB($down['size_type'], 1, str));
	$vars['filetype'] = filetypecheck(SafeDB($down['url'], 250, str));
	$vars['allow_votes'] = SafeDB($down['allow_votes'], 1, bool);

	$vars['addvote_url'] = 'index.php?name=downloads&amp;op=addvote&amp;file='.$id.'&amp;cat='.$cat_id;
	$site->DataAdd($vdata, '0', ' ');
	$site->DataAdd($vdata, '1', '1');
	$site->DataAdd($vdata, '2', '2');
	$site->DataAdd($vdata, '3', '3');
	$site->DataAdd($vdata, '4', '4');
	$site->DataAdd($vdata, '5', '5');

	$vars['votes'] = $site->Select('vote', $vdata);
	$vars['addvotesubm'] = $site->Submit(' ');

	if($down['image'] != ''){
		$vars['image'] = RealPath2($config['downloads']['images_dir'].SafeDB($down['image'], 255, str));
		$vars['thumb_image'] = RealPath2($config['downloads']['images_dir'].'thumbs/'.SafeDB($down['image'], 255, str));
	}else{
		$vars['image'] = false;
	}

	// rating
	$rating = GetRatingImage(SafeDB($down['votes_amount'], 11, int), SafeDB($down['votes'], 11, int));
	if($rating == '' && SafeDB($down['allow_votes'], 1, bool)){ // allow_rating
		$rating = ' ';
	}elseif(SafeDB($down['allow_votes'], 1, bool)){
		$rating = '<img src="'.$rating.'" /> (: '.SafeDB($down['votes_amount'], 11, int).')';
	}else{
		$rating = ' - ';
	}
	$vars['rating'] = $rating;
	//

	if(!SafeDB($down['allow_comments'], 1, bool)){ // allow coments
		$vars['comments'] = ' - ';
	}else{
		$vars['comments'] = SafeDB($down['comments_counter'], 11, int);
	}

	$site->AddBlock('download',true,false,'dl');
	$site->Blocks['download']['vars'] = $vars;
}

function IndexDownloadsMain()
{
	global $tree, $site, $db, $config;

	if(isset($_GET['cat'])){
		$cat = SafeEnv($_GET['cat'],11,int);
	}else{
		$cat = 0;
	}

	if(isset($_GET['page'])){
		$page = SafeEnv($_GET['page'],10,int);
	}else{
		$page = 1;
	}

	if($config['downloads']['show_catnav']=='1'){
		$tree->Catalog($cat,'IndexDownloadsGetNumItems');
	}
	if($cat != 0 || $config['downloads']['show_last'] == '1'){
		$where = ($cat != 0 ? "`category`='$cat' and " : '')."`active`='1'";
		$ex_where = GetWhereByAccess('view');
		if($ex_where != ''){
			$where .= ' and ('.$ex_where.')';
		}
		$downs = $db->Select('downloads', $where);

		SortArray($downs, 'public', true);
		$num = $config['downloads']['filesonpage'];
		$navigation = new Navigation($page);
		$navigation->GenNavigationMenu($downs, $num, 'index.php?name=downloads&amp;cat='.$cat);
		if($db->NumRows()>0){
			$site->AddTemplatedBox('','module/download.html');
			$site->AddBlock('download',true,true,'dl');
			foreach($downs as $down){
				AddDownload($down);
			}
		}elseif(!isset($tree->Cats[$cat]) && count($tree->Cats) > 0){
			$site->AddTextBox('','<center>     .</center>');
		}
	}
}

function IndexDownloadsFull()
{
	global $db, $config, $site, $tree, $user;
	if(isset($_GET['page'])){
		$nav_page = SafeEnv($_GET['page'], 11, int);
	}else{
		$nav_page = 1;
	}
	if(isset($_GET['lastpage'])){
		$last_page = true;
	}else{
		$last_page = false;
	}
	if(isset($_GET['cat'])){
		$cat = SafeEnv($_GET['cat'],11,int);
	}else{
		$cat = 0;
	}
	if(isset($_GET['file'])){
		$id = SafeEnv($_GET['file'],11,int);
	}else{
		GO('index.php?name=downloads');
	}

	$where = "`id`='$id' and `active`='1'";
	$ex_where = GetWhereByAccess('view');
	if($ex_where != ''){
		$where .= ' and ('.$ex_where.')';
	}
	$db->Select('downloads', $where);
	if($db->NumRows()==0){
		GO('index.php?name=downloads');
	}
	$file = $db->FetchRow();
	if($cat>0){
		$tree->ShowPath($cat, true, SafeDB($file['title'],255,str));
	}else{
		GO('index.php?name=downloads');
	}

	$site->AddTemplatedBox('','module/download_full.html');
	AddDetailDownload($file);

	//  
	include_once($config['inc_dir'].'posts.class.php');
	$posts = new Posts('downloads_comments', $file['allow_comments'] == '1');
	$posts->EditPageUrl = 'index.php?name=downloads&op=editpost&file='.$id.'&cat='.$cat."&page=$nav_page";
	$posts->DeletePageUrl = 'index.php?name=downloads&op=deletepost&file='.$id.'&cat='.$cat."&page=$nav_page";
	$posts->NavigationUrl = 'index.php?name=downloads&op=full&file='.$id.'&cat='.$cat;
	$posts->PostFormAction = 'index.php?name=downloads&op=addpost&file='.$id.'&cat='.$cat."&page=$nav_page";

	$posts->RenderPosts($id, 'download_comments', 'comments_navigation', $last_page, $nav_page);
	$posts->RenderForm(false, 'download_comments_form');
}

function IndexDownloadsFile()
{
	global $config, $db, $site, $user;
	$file = SafeEnv($_GET['file'],11,int);
	$where = "`id`='$file' and `active`='1'";
	$ex_where = GetWhereByAccess('view');
	if($ex_where != ''){
		$where .= ' and ('.$ex_where.')';
	}
	$db->Select('downloads', $where);
	if($db->NumRows()>0){
		$sfile = $db->FetchRow();
		$counter = SafeDB($sfile['hits'],11,int)+1;
		$db->Update('downloads',"hits='$counter'","`id`='$file'");
		$user->ChargePoints($config['points']['download_download']);
		GO(SafeDB($sfile['url'],250,str));
	}else{
		$site->AddTextBox('','<center>,    ,  , ,   .</center>');
	}
}

function IndexDownloadsAddVote()
{
	global $db, $config, $site, $user;
	$ip = getip();
	$time = time() - 86400; //1 
	$file = SafeEnv($_GET['file'], 11, int);
	$cat = SafeEnv($_GET['cat'], 11, int);
	$vote = SafeEnv($_POST['vote'], 1, int);
	$db->Delete('downloads_rating', "`time`<'$time'");
	$site->OtherMeta .= '<meta http-equiv="REFRESH" content="3; URL=index.php?name=downloads&amp;op=full&amp;cat='.$cat.'&amp;file='.$file.'">';
	$where = "`id`='$file' and `active`='1'";
	$ex_where = GetWhereByAccess('view');
	if($ex_where != ''){
		$where .= ' and ('.$ex_where.')';
	}
	$db->Select('downloads', $where);
	if($db->NumRows() > 0){
		$dfile = $db->FetchRow();
		if($dfile['allow_votes']=='1'){ //  
			$db->Select('downloads_rating',"`ip`='$ip'");
			if($db->NumRows()>0){
				$site->AddTextBox('','<center>     .<br /><br /><a href="javascript:history.go(-1)"></a></center>');
			}else{
				if($vote==0){
					$site->AddTextBox('','<center>   .<br /><br /><a href="javascript:history.go(-1)"></a></center>');
				}else{
					$user->ChargePoints($config['points']['download_rating']);
					$time = time();
					$db->Insert('downloads_rating',"'','$file','$ip','$time'");
					$vote = SafeDB($dfile['votes'],11,int)+$vote;
					$numvotes = SafeDB($dfile['votes_amount'],11,int)+1;
					$db->Update('downloads',"votes_amount='$numvotes',votes='$vote'","`id`='$file'");
					$cat = SafeEnv($_GET['cat'],11,int);
					$site->AddTextBox('','<center>   .<br><br><a href="javascript:history.go(-1)"></a></center>');
				}
			}
		}else{
			// 
			$site->AddTextBox('','<center>,    .<br><br><a href="javascript:history.go(-1)"></a></center>');
		}
	}else{
		//  
		$site->AddTextBox('','<center> . ,    ,      .    .<br><br><a href="javascript:history.go(-1)"></a></center>');
	}
}

function IndexDownloadsAddPost()
{
	$cat = SafeEnv($_GET['cat'],11,int);
	if(isset($_GET['page'])){
		$nav_page = SafeEnv($_GET['page'], 11, int);
	}else{
		$nav_page = 1;
	}

	global $db, $config, $site, $user;
	$get_id          = 'file'; //    get   id 
	$table           = 'downloads_comments'; //  
	$object_table    = 'downloads'; //  
	$counter_field   = 'comments_counter'; //      
	$alloy_field     = 'allow_comments' ;    //      
	$id = SafeEnv($_GET[$get_id],11,int);

	$db->Select($object_table, "`id`='$id'");
	$obj = $db->FetchRow();
	$alloy_comments = $obj[$alloy_field] == '1';

	$back_url = 'index.php?name=downloads&op=full&file='.$id.'&cat='.$cat; //  

	$parent = $_POST['parent_id'];
	$parent = explode('_', $parent, 2);
	$post_parent_id = SafeEnv($parent[1],11,int);
	if($post_parent_id == '0'){
		$back_url .= '&lastpage=1';
	}else{
		$back_url .= '&page='.$nav_page;
	}

	include_once($config['inc_dir'].'posts.class.php');
	$posts = new Posts($table, $alloy_comments);

	if($posts->SavePost($id, false)){
		$db->Select($object_table, "`id`='$id'");
		$obj = $db->FetchRow();
		$counter = $obj[$counter_field] + 1;
		$last_post = time();
		$db->Update($object_table, "`$counter_field`='$counter'", "`id`='$id'");
		GO($back_url.'#post_'.$db->GetLastId());
	}else{
		$site->AddTextBox('', $posts->PrintErrors());
	}
}

function IndexDownloadsEditPost()
{
	$cat = SafeEnv($_GET['cat'],11,int);
	if(isset($_GET['page'])){
		$nav_page = SafeEnv($_GET['page'], 11, int);
	}else{
		$nav_page = 1;
	}

	global $site, $config;
	$get_id = 'file'; //    get   id 
	$table = 'downloads_comments'; //  

	$id = SafeEnv($_GET[$get_id],11,int);

	include_once($config['inc_dir'].'posts.class.php');
	$posts = new Posts($table);

	$site->AddTemplatedBox('','edit_comment.html');
	$posts->PostFormAction = 'index.php?name=downloads&op=savepost&file='.$id.'&cat='.$cat."&page=$nav_page";
	$posts->RenderForm(true, 'post_form');
}

function IndexDownloadsEditPostSave()
{
	$cat = SafeEnv($_GET['cat'],11,int);
	if(isset($_GET['page'])){
		$nav_page = SafeEnv($_GET['page'], 11, int);
	}else{
		$nav_page = 1;
	}

	global $config;
	$get_id = 'file'; //    get   id 
	$table = 'downloads_comments'; //  

	$id = SafeEnv($_GET[$get_id],11,int);

	include_once($config['inc_dir'].'posts.class.php');
	$posts = new Posts($table);
	if($posts->SavePost($id, true)){
		GO('index.php?name=downloads&op=full&file='.$id.'&cat='.$cat."&page=$nav_page".'#post_'.SafeEnv($_GET['post_id'],11,int));
	}else{
		$site->AddTextBox('', $posts->PrintErrors());
	}
}

function IndexDownloadsDeletePost()
{
	$cat = SafeEnv($_GET['cat'],11,int);
	if(isset($_GET['page'])){
		$nav_page = SafeEnv($_GET['page'], 11, int);
	}else{
		$nav_page = 1;
	}

	global $config, $db;
	$get_id = 'file'; //    get   id 
	$table = 'downloads_comments'; //  
	$object_table = 'downloads'; //  
	$counter_field = 'comments_counter'; //      

	$id = SafeEnv($_GET[$get_id], 11, int);
	include_once($config['inc_dir'].'posts.class.php');
	$posts = new Posts($table);
	$posts->DeletePageUrl = 'index.php?name=downloads&op=deletepost&file='.$id.'&cat='.$cat."&page=$nav_page";
	$deleted_posts_count = $posts->DeletePost();

	if($deleted_posts_count > 0){
		$db->Select($object_table, "`id`='$id'");
		$obj = $db->FetchRow();
		$counter = $obj[$counter_field] - $deleted_posts_count;
		$last_post = time();
		$db->Update($object_table, "`$counter_field`='$counter'", "`id`='$id'");
		GO('index.php?name=downloads&op=full&file='.$id.'&cat='.$cat."&page=$nav_page");
	}
}

$site->Title = ' ';

if(isset($_GET['op'])){
	$op = $_GET['op'];
}else{
	$op = 'main';
}

switch($op){
	case 'main': IndexDownloadsMain();
	break;
	case 'full': IndexDownloadsFull();
	break;
	case 'download': IndexDownloadsFile();
	break;
	case 'addvote': IndexDownloadsAddVote();
	break;
	// 
	case 'addpost': IndexDownloadsAddPost();
		break;
	case 'editpost': IndexDownloadsEditPost();
		break;
	case 'savepost': IndexDownloadsEditPostSave();
		break;
	case 'deletepost': IndexDownloadsDeletePost();
		break;
	// //
	default:
		HackOff();
}



?>