<?php
#     
#
#  -  	(smilesoft@yandex.ru)
# : cache.class.php


class Forum_Cache_File
{
	var $location;	//   
	var $filename;	//     -  
	var $extension; //   
	var $close;//  true -      (  )
	private $name;	//         -      
	var $auto_unlink = true; //      
	var $auto_unlink_bounded_cache_files = array(); //     
	//    	 -       
	var $cache_duration = 60;//      : 0 - (      )

	function Forum_Cache_File($location, $filename, $extension, $close)
	{
		$this->close = $close	;
		if($this->close) return false;
		$this->location = $location;
		$this->filename = rawurlencode($filename);
		$this->extension = rawurlencode($extension);
		$this->name = $location.$this->filename.'.'.$this->extension;
	}

	function save($data, $main_name='')
	{	
	if($this->close)return true;
	if($main_name <> ''){
	$main_name = $this->location.$main_name.'.'.$this->extension;
	}
	else
		{
	       $main_name = $this->name;
		}
	if(!is_dir($this->location)){
		mkdir($this->location, 0755);
	}
	if (file_exists($main_name) && is_writeable($main_name ) || file_exists($this->location) && is_writeable($this->location))
	{
		$data = serialize($data);

		if (function_exists('file_put_contents'))
		{
			return (bool) file_put_contents($main_name, $data);
		}
		else
		{
			$fp = fopen($main_name, 'wb');
			if ($fp)
			{
				fwrite($fp, $data);
				fclose($fp);
				return true;
			}
		}
	}
	return false;
	}


	function load()
	{	
	if($this->close)return false;

	if (file_exists($this->name) && is_readable($this->name))
	{
		if( ($this->auto_unlink and $this->mtime() +  $this->cache_duration > time()) or (!$this->auto_unlink) or ( $this->cache_duration == 0))
		{
			return unserialize(file_get_contents($this->name));
		}
		else
		{
			$this->unlink()	;
			return false;
		}
	}
	return false;
	}


	function load2($main_name='')
	{	
	if($this->close)return false;
	if($main_name <> ''){
	$main_name = $this->location.$main_name.'.'.$this->extension;
	}
	else
		{
	       return	 false;
		}

	if (file_exists($main_name))
	{
			return unserialize(file_get_contents($main_name));
		}
		else
		{
			return false;
		}
	return false;
	}



	function mtime()
	{
		if (file_exists($this->name))
		{
			return filemtime($this->name);
		}
		return false;
	}
	function mtime2($name)
	{
		if (file_exists($name))
		{
			return filemtime($name);
		}
		return false;
	}

	function touch()
	{
		if (file_exists($this->name))
		{
			return touch($this->name);
		}
		return false;
	}



	function unlink()
	{
		if (file_exists($this->name))
		{
			if(count($this->auto_unlink_bounded_cache_files)>0)
			{
				foreach($this->auto_unlink_bounded_cache_files as $del_file)
				{
					unlink($location.$del_file.'.'.$this->extension);
				}
			}
			return unlink($this->name);
		}
		return false;
	}
}


/********************************************************************/

class Forum_Clear_Cache_File
{
	var $location ;	//      
	var $cache_durations = 600;//      
	var $main_Location ;//
	var $name ;//
	function Forum_Clear_Cache_File($location, $main_Location)
	{
		$this->location = $location;
		$this->main_Location = $main_Location;
		$this->name = $this->main_Location.'chekfile.dat';
	}

function ScanFileUnlink()
{
	$mtime = 0;
		if (file_exists($this->name))
	  $mtime =  $this->mtimec($this->name);

if(($mtime +  ($this->cache_durations*2) )< time())
	{
		$files = array();
		$folder = $this->location;
		$dir = @opendir($folder);
		while($file = @readdir($dir)){
			if($file != '.' && $file != '..' ){
				$files[] = $file;
			}
		}
		if(count($files)>0)
		{
			foreach($files as $file)
			{
			  $this->Clear($this->location.$file);
			}
		}
	  $data = time(); 
	  $fp = fopen($this->name, 'wb');
			if ($fp)
			{
				fwrite($fp, $data);
				fclose($fp);
				return true;
			}
	}
}

	function Clear($file)
	{	
		if( $this->mtimec($file) +  $this->cache_durations < time())
		{	
			$this->unlinkc($file);
		}
	}

	function mtimec($file)
	{
		return filemtime($file);
	}

	function unlinkc($file)
	{
		if (file_exists($file))
		{
			 @unlink($file);
			 
		}
		return false;
	}
}

?>