<?php
# LinkorCMS
# LinkorCMS Development Group
# www.linkorcms.ru
#  LinkorCMS 1.2.
# 

define("FORUM_CACHE_DIR",'cache/forum/');
define("FORUM_CACHE_ALL_DATA_FORUMS",'Forum_Cache_AllDataTableForum');
define("FORUM_CACHE_ALL_DATA_FORUM_TOPICS",'Forum_Cache_AllDataTableForumTopics');


function Forum_Cache_Topic_DataFilter( &$topic)
{	
	$topic2 = array();
	$topic2['id'] = $topic['id'];
	$topic2['forum_id'] = $topic['forum_id'];
	$topic2['title'] = $topic['title'];
	$topic2['state'] = $topic['state'];
	$topic2['posts'] = $topic['posts'];
	$topic2['hits'] = $topic['hits'];
	$topic2['start_date'] = $topic['start_date'];
	$topic2['starter_id'] = $topic['starter_id'];
	$topic2['starter_name'] = $topic['starter_name'];
	$topic2['last_post'] = $topic['last_post'];
	$topic2['last_poster_id'] = $topic['last_poster_id'];
	$topic2['last_poster_name'] = $topic['last_poster_name'];
	$topic2['uniq_code'] = $topic['uniq_code'];
	$topic2['close_topics'] = $topic['close_topics'];
	$topic2['stick'] = $topic['stick'] ;
	$topic2['delete'] = $topic['delete'];
	return $topic2;
}

function Forum_Cache_Forum_DataFilter( &$forum)
{	
$forum2 = array();
$forum2['id'] =$forum['id'];
$forum2['parent_id'] = $forum['parent_id'];
$forum2['title'] = $forum['title'];
$forum2['description'] =$forum['description'];
$forum2['topics'] = $forum['topics'];
$forum2['posts'] =$forum['posts'];
$forum2['last_post_date'] = $forum['last_post'];
$forum2['last_post'] = $forum['last_post'];
$forum2['last_poster_id'] = $forum['last_poster_id'];
$forum2['last_poster_name'] = $forum['last_poster_name'];
$forum2['last_title'] = $forum['last_title'];
$forum2['last_id'] = $forum['last_id'];
$forum2['order'] = $forum['order'];
$forum2['status'] = $forum['status'];
$forum2['view'] =$forum['view'];
$forum2['admin_theme_add'] =$forum['admin_theme_add'];
$forum2['new_message_email'] =$forum['new_message_email'];
$forum2['no_link_guest'] = $forum['no_link_guest'];
$forum2['rang_access'] = $forum['rang_access'];
$forum2['rang_message'] = $forum['rang_message'];
$forum2['rang_add_theme'] =$forum['rang_add_theme'];
$forum2['close_topic'] = $forum['close_topic'];
return $forum2;
}


/*     forum_topics  */
function Forum_Cache_AllDataTableForumTopics()
{	  global $db, $config;
static $forum_topics = array();
static $qwerytopic = false;

if(!$qwerytopic){
Forum_Cache_CacheCreate(&$cache, FORUM_CACHE_ALL_DATA_FORUM_TOPICS, 0);
if(!$forum_topics = $cache->load())
{	
	$forum_topics = $db->Select('forum_topics');
	$qwerytopic = true;
	if($config['forum']['cache'])
	{
		if($config['forum']['cache'])
	    {
			foreach($forum_topics as $forum_topic)
			{
			 $topics[] = Forum_Cache_Topic_DataFilter( $forum_topic); 
			}
			$cache->save($topics);
		}
	}
}
else
{
if($config['forum']['cache'])
	$qwerytopic = true;
}
}
return $forum_topics ;
}


/*     forums  */
function Forum_Cache_AllDataTableForum()
{ global $db, $config;
static $forums  = array();
static $qweryf = false;
if(!$qweryf ){
Forum_Cache_CacheCreate(&$cache, FORUM_CACHE_ALL_DATA_FORUMS, 0);
	if(!$forums = $cache->load())
{
    $forums = $db->Select('forums',"`status`='1'");	 
	$qweryf = true;
	if($config['forum']['cache'])
	{
		if($config['forum']['cache']){
			
				foreach($forums as $forum)
			{
			 $mforums[] = Forum_Cache_Forum_DataFilter( $forum); 
			}
			$cache->save($mforums);
	}
	}
}
else
{
	$qweryf = true;
}
}
return $forums ;
}

function Forum_Cache_AllUpdateCache()
{
	global $config;
	if($config['forum']['cache'])
	{
		$array = Forum_Cache_AllDataTableForum();
		unset($array);
		$array = Forum_Cache_AllDataTableForumTopics();
		unset($array);
	}
}

function Forum_Cache_ClearAllCacheForum()
{
global $config;
static $clear = false;
if($config['forum']['cache'])
{
	if(!$clear)
	{
		$files = array();
		$folder = FORUM_CACHE_DIR;
		$dir = @opendir($folder);
		while($file = @readdir($dir)){
			if($file != '.' && $file != '..' ){
				$files[] = $file;
			}
		}
		if(count($files)>0)
		{
			foreach($files as $file)
			@unlink($folder.$file);
		}
		Forum_Cache_AllUpdateCache();
		$clear = true;
	}
}
}


/**
*  
* file_name -           
* cache_duration -      : 0 -  (            -  ""       .)
* auto_unlink -           
* auto_unlink_bounded_cache_files	-         
*   	,       
**/
function Forum_Cache_CacheCreate(&$cache, $file_name, $cache_duration = 600, $auto_unlink = true , $auto_unlink_bounded_cache_files = array())
{	static $clear = false;
	global $config;
  if($config['forum']['cache'])
	{
		if(!is_dir('cache')){
			mkdir('cache', 0755);
		}
	}
	if(!$config['forum']['update_cache_in_add'] and $cache_duration<1 )
	$cache_duration = $config['forum']['maxi_cache_duration'];
	$cache = new Forum_Cache_File(FORUM_CACHE_DIR, $file_name, 'cache', !$config['forum']['cache']);
	 if(!$config['forum']['cache'])	 return;
	$cache->auto_unlink = $auto_unlink;
	$cache->cache_duration = $cache_duration;
	$cache->auto_unlink_bounded_cache_files = $auto_unlink_bounded_cache_files;
	if($config['forum']['cache'])
	{
		if(!$clear){
		$clear_cache = new Forum_Clear_Cache_File(FORUM_CACHE_DIR, 'cache/') ;
		$clear_cache->cache_duration = $cache_duration; 
		$clear_cache->ScanFileUnlink();
		}
	}
}

?>