<?php

if(!defined('VALID_RUN')){
	Header("Location: http://".getenv("HTTP_HOST")."/index.php");
	exit();
}

$site->Title = '';

//
include_once ($config['inc_dir'].'tree_b.class.php');
$tree = new IndexTree('gallery_cats');
$tree->moduleName = 'gallery';
$tree->catTemplate = 'module/download_cat.html';
$tree->id_par_name = 'cat';
$tree->NumItemsCaption = '<center>   : ';
$tree->TopCatName = '';
$GalleryDir = $config['gallery']['gallery_dir'];
$ThumbsDir = $config['gallery']['thumbs_dir'];

function IndexGalleryGetNumItems()
{
	global $db;
	$ex_where = GetWhereByAccess('view');
	$db->Select('gallery', '`show`=\'1\''.($ex_where != '' ? ' and '.$ex_where : ''));
	return $db->NumRows().'.</center>';
}

function RenderThumb( $title, $filename, $description, $comments, $link )
{
	global $site, $ThumbsDir, $GalleryDir;
	$vars = array();
	$vars['title'] = $title;
	$vars['description'] = $description;
	$thumbfile = $ThumbsDir.$filename;
	$vars['thumb_src'] = $thumbfile;
	$vars['image_view'] = $link;
	if(is_file($GalleryDir.$filename)){
		$size = FormatFileSize(filesize($GalleryDir.$filename));
		$vars['size'] = $size;
		$asize = getimagesize($GalleryDir.$filename);
		$asize = $asize[0].'x'.$asize[1];
		$vars['asize'] = $asize;
	}
	$vars['lcomments'] = '';
	$vars['comments'] = $comments;
	$site->AddTableCell('gallery_images', true, $vars);
}

function RenderImageView( $title, $imgsrc, $description )
{
	global $site, $GalleryDir;
	$vars = array();
	$vars['title'] = $title;
	$vars['image_view_full'] = $GalleryDir.$imgsrc;
	$vars['image_src'] = $GalleryDir.$imgsrc;
	$vars['ldescription'] = '';
	$vars['description'] = $description;
	$site->AddBlock('gallery_image', true, false, 'img');
	$site->Blocks['gallery_image']['vars'] = $vars;
}

function IndexGalleryView()
{
	global $db, $config, $site, $tree, $user;
	if(isset($_GET['page'])){
		$nav_page = SafeEnv($_GET['page'], 11, int);
	}else{
		$nav_page = 1;
	}
	if(isset($_GET['lastpage'])){
		$last_page = true;
	}else{
		$last_page = false;
	}
	if(isset($_GET['cat'])){
		$cat = SafeEnv($_GET['cat'], 11, int);
	}else{
		$cat = 0;
	}
	$where = "`cat_id`='$cat' and `show`='1'";
	$ex_where = GetWhereByAccess('view');
	if($ex_where != ''){
		$where .= ' and ('.$ex_where.')';
	}
	$img = $db->Select('gallery', $where);
	SortArray($img, 2, true);
	if(isset($_GET['img'])){
		$id = SafeEnv($_GET['img'], 11, int);
		for($i = 0, $cnt = count($img); $i < $cnt; $i++){
			if($img[$i][0] == $id){
				$pimg = $i + 1;
			}
		}
	}else{
		if(isset($_GET['pimg'])){
			$pimg = SafeEnv($_GET['pimg'], 10, int);
			$id = $img[$pimg - 1][0];
		}else{
			$pimg = 1;
		}
	}

	$navigation = new Navigation($pimg, 'navigation', 'pimg');
	$navigation->GenNavigationMenu($img, 1, 'index.php?name=gallery&amp;op=view&amp;cat='.$cat);

	//  
	$img = $img[0];
	if($cat > 0){
		$tree->ShowPath($cat, true, SafeDB($img[3], 255, str));
	}else{
		GO('index.php?name=gallery');
	}
	$site->AddTemplatedBox('', 'module/gallery_view.html');
	RenderImageView(SafeDB($img[3], 255, str), SafeDB($img[5], 255, str), SafeDB($img[4], 0, str, false, false));
	$db->Update('gallery', "hits='".(SafeDB($img[6], 11, int) + 1)."'", "`id`='$id'");

	//  
	include_once($config['inc_dir'].'posts.class.php');
	$posts = new Posts('gallery_comments', $img['allow_comments'] == '1');
	$posts->EditPageUrl = 'index.php?name=gallery&op=editpost&img='.$id.'&cat='.$cat."&page=$nav_page";
	$posts->DeletePageUrl = 'index.php?name=gallery&op=deletepost&img='.$id.'&cat='.$cat."&page=$nav_page";
	$posts->NavigationUrl = 'index.php?name=gallery&op=view&img='.$id.'&cat='.$cat;
	$posts->PostFormAction = 'index.php?name=gallery&op=addpost&img='.$id.'&cat='.$cat."&page=$nav_page";

	$posts->RenderPosts($id, 'gallery_comments', 'comments_navigation', $last_page, $nav_page);
	$posts->RenderForm(false, 'gallery_comments_form');
}

function IndexGalleryShow( $cat )
{
	global $db, $config, $site, $tree;
	$thumbs_onrow = $config['gallery']['thumbs_onrow'];
	if(isset($_GET['page'])){
		$page = SafeEnv($_GET['page'], 10, int);
	}else{
		$page = 1;
	}
	$where = "`cat_id`='$cat' and `show`='1'";
	$ex_where = GetWhereByAccess('view');
	if($ex_where != ''){
		$where .= ' and ('.$ex_where.')';
	}
	$images = $db->Select('gallery', $where);
	SortArray($images, 2, true);
	$num = $config['gallery']['images_on_page'];

	$navigation = new Navigation($page);
	$navigation->GenNavigationMenu($images, $num, 'index.php?name=gallery&amp;cat='.$cat);

	if($db->NumRows() > 0){
		$site->AddTemplatedBox('', 'module/gallery_image.html');
		$site->AddTable('gallery_images', true, 'img', $thumbs_onrow);
		foreach($images as $img){
			RenderThumb(SafeDB($img[3], 255, str), SafeDB($img[5], 255, str), SafeDB($img[4], 0, str), SafeDB($img[11], 11, int), 'index.php?name=gallery&amp;op=view&amp;img='.SafeDB($img[0], 11, int).'&amp;cat='.SafeDB($img[1], 11, int));
		}
	}elseif(!isset($tree->Cats[$cat]) && count($tree->Cats) > 0){
		$site->AddTextBox('', '<center> .</center>');
	}
}

function IndexGalleryAddPost()
{
	$cat = SafeEnv($_GET['cat'],11,int);
	if(isset($_GET['page'])){
		$nav_page = SafeEnv($_GET['page'], 11, int);
	}else{
		$nav_page = 1;
	}

	global $db, $config, $site, $user;
	$get_id = 'img'; //    get   id 
	$table = 'gallery_comments'; //  
	$object_table = 'gallery'; //  
	$counter_field = 'com_counter'; //      
	$alloy_field     = 'allow_comments';     //      
	$id = SafeEnv($_GET[$get_id],11,int);

	$db->Select($object_table, "`id`='$id'");
	$obj = $db->FetchRow();
	$alloy_comments = $obj[$alloy_field] == '1';

	$back_url = 'index.php?name=gallery&op=view&img='.$id.'&cat='.$cat; //  

	$parent = $_POST['parent_id'];
	$parent = explode('_', $parent, 2);
	$post_parent_id = SafeEnv($parent[1],11,int);
	if($post_parent_id == '0'){
		$back_url .= '&lastpage=1';
	}else{
		$back_url .= '&page='.$nav_page;
	}

	include_once($config['inc_dir'].'posts.class.php');
	$posts = new Posts($table, $alloy_comments);

	if($posts->SavePost($id, false)){
		$db->Select($object_table, "`id`='$id'");
		$obj = $db->FetchRow();
		$counter = $obj[$counter_field] + 1;
		$last_post = time();
		$db->Update($object_table, "`$counter_field`='$counter'", "`id`='$id'");
		GO($back_url.'#post_'.$db->GetLastId());
	}else{
		$site->AddTextBox('', $posts->PrintErrors());
	}
}

function IndexGalleryEditPost()
{
	$cat = SafeEnv($_GET['cat'],11,int);
	if(isset($_GET['page'])){
		$nav_page = SafeEnv($_GET['page'], 11, int);
	}else{
		$nav_page = 1;
	}

	global $site, $config;
	$get_id = 'img'; //    get   id 
	$table = 'gallery_comments'; //  

	$id = SafeEnv($_GET[$get_id],11,int);

	include_once($config['inc_dir'].'posts.class.php');
	$posts = new Posts($table);

	$site->AddTemplatedBox('','edit_comment.html');
	$posts->PostFormAction = 'index.php?name=gallery&op=savepost&img='.$id.'&cat='.$cat."&page=$nav_page";
	$posts->RenderForm(true, 'post_form');
}

function IndexGalleryEditPostSave()
{
	$cat = SafeEnv($_GET['cat'],11,int);
	if(isset($_GET['page'])){
		$nav_page = SafeEnv($_GET['page'], 11, int);
	}else{
		$nav_page = 1;
	}

	global $config;
	$get_id = 'img'; //    get   id 
	$table = 'gallery_comments'; //  

	$id = SafeEnv($_GET[$get_id],11,int);

	include_once($config['inc_dir'].'posts.class.php');
	$posts = new Posts($table);
	if($posts->SavePost($id, true)){
		GO('index.php?name=gallery&op=view&img='.$id.'&cat='.$cat."&page=$nav_page".'#post_'.SafeEnv($_GET['post_id'],11,int));
	}else{
		$site->AddTextBox('', $posts->PrintErrors());
	}
}

function IndexGalleryDeletePost()
{
	$cat = SafeEnv($_GET['cat'],11,int);
	if(isset($_GET['page'])){
		$nav_page = SafeEnv($_GET['page'], 11, int);
	}else{
		$nav_page = 1;
	}

	global $config, $db;
	$get_id = 'img'; //    get   id 
	$table = 'gallery_comments'; //  
	$object_table = 'gallery'; //  
	$counter_field = 'com_counter'; //      

	$id = SafeEnv($_GET[$get_id], 11, int);
	include_once($config['inc_dir'].'posts.class.php');
	$posts = new Posts($table);
	$posts->DeletePageUrl = 'index.php?name=gallery&op=deletepost&img='.$id.'&cat='.$cat."&page=$nav_page";
	$deleted_posts_count = $posts->DeletePost();

	if($deleted_posts_count > 0){
		$db->Select($object_table, "`id`='$id'");
		$obj = $db->FetchRow();
		$counter = $obj[$counter_field] - $deleted_posts_count;
		$last_post = time();
		$db->Update($object_table, "`$counter_field`='$counter'", "`id`='$id'");
		GO('index.php?name=gallery&op=view&img='.$id.'&cat='.$cat."&page=$nav_page");
	}
}

if(isset($_GET['op'])){
	$op = $_GET['op'];
}else{
	$op = 'main';
}

switch($op){
	case 'main':
		if(isset($_GET['cat'])){
			$cat = SafeEnv($_GET['cat'], 11, int);
		}else{
			$cat = 0;
		}
		$tree->Catalog($cat, 'IndexGalleryGetNumItems');
		if($cat != 0){
			IndexGalleryShow($cat);
		}
		break;
	case 'view':
		IndexGalleryView();
		break;
	// 
	case 'addpost': IndexGalleryAddPost();
		break;
	case 'editpost': IndexGalleryEditPost();
		break;
	case 'savepost': IndexGalleryEditPostSave();
		break;
	case 'deletepost': IndexGalleryDeletePost();
		break;
	// //
	default:
		HackOff();
}

?>