<?php

# LinkorCMS
#  2006-2007    (galitsky@pochta.ru)
# :			database/mysql.layer.php
# :	  MySQL  

/*----------------------------------------------
//  

*** 1.0.0.

*** 1.1.0 - 3.08.2008

-           .
-    Database  Database_MySQL

*** 1.2.0 - 15.07.2009

-   GetLastId().


----------------------------------------------*/

if(!defined('VALID_RUN')){
	Header("Location: http://".getenv("HTTP_HOST")."/index.php");
	exit();
}

class LcDatabaseMySQL
{
	//   //
	public $Server; //     (  )
	public $User; //    .  .
	public $Password; //   .  .
	public $SelectDbName; //    (       )
	public $Prefix = 'table'; //    
	public $Connected = false; //       
	public $DbSelected = false; //     

	//    //
	public $QueryResult; //   
	public $MySQLQueryResult; //      MySQL

	//   //
	public $QueryTotalTime = 0; //     (.)
	public $QueryTime = 0; //    (.)
	public $NumQueries = 0; //      

	//   //
	public $AllErrors; //   
	public $ErrorReporting = false; //      
	public $Error = false; //       
	public $ErrorMsg = ''; //          ,   

	//   //
	public $QueryLayer = 0; //    . .
	public $Method = ''; //      . , .
	public $Name = 'MySQl'; //   
	public $Version = ''; //   

	function __construct()
	{
		$this->QueryResult = array();
		$this->AllErrors = array();
	}

	private function Now()
	{
		return microtime(true);
	}

	protected function Error( $msg )
	{
		$msg = '<p><b>'.$this->Method.'</b>: '.$msg.'<p>';
		$this->ErrorMsg = $msg;
		$this->AllErrors[] = $msg;
		$this->Error = true;
		if($this->ErrorReporting){
			//echo $msg."\n";
			error_handler(USER_WARNING, $msg, __FILE__, __LINE__);

		}
		$this->EndQ();
	}

	public function Prefix()
	{
		return ($this->Prefix == '' ? '' : $this->Prefix.'_');
	}

	private function MySQLError( $err = 0, $msg = '' )
	{
		if($this->Connected){
			$this->Error(($err == 0 ? '<p><b>Database->MySQLError()</b> '.mysql_errno($this->DbAccess) : $err).': '.($msg == '' ? mysql_error($this->DbAccess) : $msg).'</p>');
		}
	}

	private function MySQLGetErrNo()
	{
		return mysql_errno($this->DbAccess);
	}

	private function MySQLGetErrMsg()
	{
		return mysql_error($this->DbAccess);
	}

	public function MySQLQuery( $query )
	{
		if($query != '' && $this->Connected){
			return $this->QueryResult = $this->MySQLQueryResult = @mysql_query($query, $this->DbAccess);
		}
	}

	private function MySQLQuery2( $query, $error_msg )
	{
		if($this->MySQLQuery($query)){
			$this->Good();
			return true;
		}else{
			$this->Error($error_msg);
			$this->MySQLError();
			return false;
		}
	}

	protected function Good()
	{
		$this->EndQ();
		$this->ErrorMsg = '';
		$this->Error = false;
	}

	protected function StartQ( $method = '' )
	{
		$this->QueryLayer++;
		if($this->QueryLayer == 1){
			$this->QueryTime = $this->now();
			$this->NumQueries++;
			$this->Method = $method;
		}
	}

	protected function EndQ()
	{
		if($this->QueryLayer > 0){
			$this->QueryLayer--;
			if($this->QueryLayer == 0){
				$this->QueryTime = $this->Now() - $this->QueryTime;
				$this->QueryTotalTime += $this->QueryTime;
				$this->Method = '';
			}
		}
	}

	//   
	protected function SetResult( $result )
	{
		$result_array = array();
		$nr = mysql_num_rows($result);
		if($nr > 0){
			mysql_data_seek($result, 0);
		}
		while($r = @mysql_fetch_array($result, MYSQL_BOTH)){
			$result_array[] = $r;
		}
		if($nr > 0){
			mysql_data_seek($result, 0);
		}
		$this->QueryResult = $result_array;
		Reset($this->QueryResult);
		return $this->QueryResult;
	}

	//       
	public function Connect( $host, $user, $pass, $dbname = "" )
	{
		if($this->Connected){
			$this->Disconnect();
		}
		$this->Server = $host;
		$this->User = $user;
		$this->Password = $pass;
		ErrorsOff();
		$this->DbAccess = @mysql_connect($this->Server, $this->User, $this->Password);
		ErrorsOn();
		if($this->DbAccess){
			$this->Connected = true;
			@mysql_query("set character_set_client='cp1251'");
			@mysql_query("set character_set_results='cp1251'");
			@mysql_query("set collation_connection='cp1251_general_ci'");
			$this->Version = mysql_get_server_info();
			if($dbname != "" && @mysql_select_db($dbname, $this->DbAccess)){
				$this->SelectDbName = $dbname;
				$this->DbSelected = true;
			}
		}else{
			$this->Error('    !');
			$this->MySQLError();
			return false;
		}
		$this->Good();
		return true;
	}

	//     
	public function Disconnect()
	{
		$this->StartQ('Database->Disconnect()');
		if(!$this->Connected){
			$this->Error('    .');
			return false;
		}
		if($this->QueryResult){
			@mysql_free_result($this->QueryResult);
		}
		$result = @mysql_close($this->DbAccess);
		if($result){
			$this->Server = '';
			$this->User = '';
			$this->Password = '';
			if($this->DbSelected){
				$this->SelectDbName = '';
				$this->DbSelected = false;
			}
			$this->Connected = false;
			$this->Good();
			return true;
		}
	}

	//   
	public function CreateDb( $Name, $dropIfExists = false )
	{
		$this->StartQ('Database->CreateDb()');
		$query = "CREATE DATABASE $Name";
		if(version_compare(mysql_get_server_info(), '4.1', '>') ? '1' : '0'){
			$query .= ' DEFAULT CHARACTER SET cp1251 COLLATE cp1251_general_ci';
		}
		;
		$this->MySQLQuery($query);
		$test = $this->MySQLGetErrNo();
		$msg = $this->MySQLGetErrMsg();
		if($dropIfExists && $test == 1007){
			$this->DropDb($Name);
			$this->CreateDb($Name, false);
			$this->Good();
			return true;
		}
		if($test != 0){
			$this->Error('     '.$test.'.');
			$this->MySQLError($test, $msg);
			return false;
		}else{
			$this->Good();
			return true;
		}
	}

	//  .
	public function DropDb( $Name )
	{
		$this->StartQ('Database->DropDb()');
		$this->MySQLQuery("DROP DATABASE IF EXISTS $Name");
		if($this->MySQLGetErrNo() != 0){
			$this->Error('    .');
			$this->MySQLError();
			return false;
		}else{
			$this->Good();
			return true;
		}
	}

	// 
	public function SelectDb( $name )
	{
		$this->StartQ('Database->SelectDb()');
		if($this->DbAccess){
			if(@mysql_select_db($name)){
				$this->SelectDbName = $name;
				$this->DbSelected = true;
				$this->Good();
				return true;
			}else{
				$this->Error('  "'.$name.'"  !');
				return false;
			}
		}else{
			$this->Error('     !');
			return false;
		}
	}

	protected function CollToSql( $coll, $oldCollName = '' )
	{
		$sql = '';
		if($oldCollName != ''){
			$sql .= '  `'.$oldCollName.'`';
		}
		$sql .= '  `'.$coll['name'].'`';
		$sql .= ' '.$coll['type'];
		if(isset($coll['length'])){
			$sql .= '('.$coll['length'].')';
		}
		if(isset($coll['attributes'])){
			$sql .= ' '.$coll['attributes'];
		}
		if(isset($coll['notnull'])){
			$sql .= ' NOT NULL';
		}
		if(isset($coll['auto_increment'])){
			$sql .= ' auto_increment';
		}elseif(isset($coll['default'])){
			$sql .= ' default \''.$coll['default'].'\'';
		}
		return $sql;
	}

	//  
	public function CreateTable( $name, $query, $dropex = false )
	{
		$this->StartQ('Database->CreateTable()');
		$sql = 'CREATE TABLE '.$this->Prefix().$name.' ('."\n";
		$ccnt = count($query['cols']);
		$ckeys = 0;
		$keys = '';
		$primary = '';
		for($i = 0; $i < $ccnt; $i++){
			$sql .= $this->CollToSql($query['cols'][$i]);
			if(isset($query['cols'][$i]['primary'])){
				$primary = '  PRIMARY KEY (`'.$query['cols'][$i]['name'].'`)';
			}elseif(isset($query['cols'][$i]['index'])){
				if($ckeys > 0){
					$keys .= ",\n";
				}
				$keys .= '  KEY `'.$query['cols'][$i]['name'].'` (`'.$query['cols'][$i]['name'].'`)';
				$ckeys++;
			}
			if($i < $ccnt - 1 || $primary != '' || $keys != ''){
				$sql .= ','."\n";
			}
		}
		if($primary != ''){
			$sql .= $primary.($keys != '' ? ',' : '')."\n";
		}
		if($keys != ''){
			$sql .= $keys."\n";
		}
		$sql .= "\n".')';
		if(isset($query['type'])){
			$sql .= ' TYPE='.$query['type'];
		}
		if(isset($query['comment'])){
			$sql .= ' COMMENT="'.$query['type'].'"';
		}
		$sql .= ';'."\n\n";
		//  
		if($dropex){
			$this->DropTable($name);
		}
		$result = $this->MySQLQuery($sql);
		if(!$result){
			$this->Error('    '.$name);
			$this->MySQLError();
			echo $sql;
			return false;
		}
		$this->Good();
		return true;
	}

	//  
	public function DropTable( $name )
	{
		$this->StartQ('Database->DropTable()');
		$sql = 'DROP TABLE IF EXISTS '.$this->Prefix().$name;
		if($this->MySQLQuery2($sql, '   .')){
			$this->Good();
			return true;
		}else{
			return false;
		}
	}

	public function RenameTable( $LastName, $NewName )
	{
		$this->StartQ('Database->RenameTable()');
		$sql = 'LTER TABLE '.$this->Prefix().$LastName.' RENAME '.$this->Prefix().$NewName;
		if($this->MySQLQuery2($sql, '   .')){
			$this->Good();
			return true;
		}else{
			return false;
		}
	}

	//  -   
	public function GetTables()
	{
		$this->StartQ('Database->GetTables()');
		$sql = 'SHOW TABLES';
		if(!$this->MySQLQuery2($sql, '.   .')){
			return false;
		}
		$this->Good();
		return $this->SetResult($this->QueryResult);
	}

	//        
	public function GetAllTablesInfo()
	{
		$this->StartQ('Database->GetAllTablesInfo()');
		$sql = 'SHOW TABLE STATUS';
		if(!$this->MySQLQuery2($sql, '.   .')){
			return false;
		}
		$infs = $this->SetResult($this->QueryResult);
		foreach($infs as $i){
			$info['name'] = ($this->Prefix != '' ? substr($i[0], strlen($this->Prefix) + 1) : $i[0]);
			$info['type'] = $i[1];
			$info['num_rows'] = $i[4];
			$info['counter'] = $i[10];
			$info['size'] = $i[6] + $i[8];
			$tables[] = $info;
		}
		reset($tables);
		$this->QueryResult = $tables;
		$this->Good();
		return $tables;
	}

	//   
	public function GetTableColumns( $tablename )
	{
		$this->StartQ('Database->GetTableColumns()');
		$sql = 'SHOW COLUMNS FROM `'.$this->Prefix().$tablename.'`';
		if(!$this->MySQLQuery2($sql, '.   .')){
			return false;
		}
		$cols = array();
		while($col = mysql_fetch_assoc($this->MySQLQueryResult)){
			$cols[] = array(
				'name'=>$col['Field'],

				'coll'=>$col
			);
		}
		reset($cols);
		$this->QueryResult = $cols;
		$this->Good();
		return $cols;
	}

	public function InsertColl( $name, $coll, $collindex )
	//  $collindex=-1      
	//  $coll       
	{
		$coll_sql = $this->CollToSql($coll);
		$after = '';
		if($collindex != -1){
			$columns = $this->GetTableColumns($name);
			if(isset($columns[$collindex])){
				$after = ' AFTER `'.$columns[$collindex]['name'].'`';
			}
		}
		$sql = 'ALTER TABLE `'.$this->Prefix().$name.'` ADD COLUMN '.$coll_sql.$after.';';
		if($this->MySQLQuery($sql)){
			return true;
		}else{
			$this->Error('.   .');
			return false;
		}
	}

	public function DeleteColl( $name, $index )
	{
		$columns = $this->GetTableColumns($name);
		if(isset($columns[$index])){
			$column_name = $columns[$index]['name'];
			$sql = 'ALTER TABLE `'.$this->Prefix().$name.'` DROP COLUMN `'.$column_name.'`;';
			if($this->MySQLQuery($sql)){
				return true;
			}else{
				$this->Error('.   .');
				return false;
			}
		}else{
			return false;
		}
	}

	public function EditColl( $name, $index, $coll )
	{
		$columns = $this->GetTableColumns($name);
		if(isset($columns[$index])){
			$sql = $this->CollToSql($coll, $columns[$index]['name']);
			$sql = 'ALTER TABLE `'.$this->Prefix().$name."` CHANGE $sql;";
			if($this->MySQLQuery($sql)){
				return true;
			}else{
				$this->Error('.   .');
				return false;
			}
		}else{
			return false;
		}
	}

	public function RenameColl( $name, $index, $newCollName )
	{
		$columns = $this->GetTableColumns($name);
		if(isset($columns[$index])){
			$column_name = $columns[$index]['name'];
			$type = $columns[$index]['coll']['Type'];
			$sql = 'ALTER TABLE `'.$this->Prefix().$name."` CHANGE `$column_name` `$newCollName` $type;";
			if($this->MySQLQuery($sql)){
				return true;
			}else{
				$this->Error('.   .');
				return false;
			}
		}else{
			return false;
		}
	}

	//    
	public function Insert( $name, $values, $cols = '' )
	{
		$this->StartQ('Database->Insert()');
		$sql = 'INSERT INTO '.$this->Prefix().$name.($cols != '' ?' ('.implode(',',$cols).')' : '').' VALUES ('.$values.')';
		if($this->MySQLQuery($sql)){
			$this->Good();
			return true;
		}else{
			$this->Error('.   .');
			$this->MySQLError();
			return false;
		}
	}

	private function Values2Set( $values, $columns )
	{
		$set = '';
		$values = str_replace("\'", "&#39;", $values);
		$values = str_replace('\"', "&#34;", $values);
		$values = trim($values);
		$maxlength = count($columns);
		for($i = 0; $i < $maxlength; $i++){
			$pos = strpos($values, "'");
			if($pos === false){
				break;
			}
			$values = substr($values, $pos + 1);
			$pos = strpos($values, "'");
			$val = substr($values, 0, $pos);
			$values = substr($values, $pos + 1);
			$val = str_replace('&#34;', '\"', $val);
			$val = str_replace("&#39;", "\'", $val);
			if($columns[$i][5] == ''){
				$set .= '`'.$columns[$i][0].'`=\''.$val.'\', ';
			}
		}
		$set = substr($set, 0, -2);
		return $set;
	}

	//    
	public function Update( $name, $set, $where = '', $setisvalues = false, $cols = '' )
	{
		$this->StartQ('Database->Update()');
		if($setisvalues){
			$cols1 = $this->SetResult($this->MySQLQuery('SHOW COLUMNS FROM '.$this->Prefix().$name));
			if($cols != ''){
				$cols2 = array();
				foreach($cols1 as $value){
					$cols2[$value[0]] = $value;
				}
				$cols3 = array();
				foreach($cols as $coll){
					$cols3[] = $cols2[$coll];
				}
			}else{
				$cols3 = &$cols1;
			}
			$set = $this->Values2Set($set, $cols3);
		}
		$sql = 'UPDATE '.$this->Prefix().$name.' SET '.$set.' WHERE '.$where;
		if($this->MySQLQuery($sql)){
			$this->Good();
			return true;
		}else{
			$this->Error('.   .');
			$this->MySQLError();
			return false;
		}
	}

	//    
	public function Delete( $name, $where = '' )
	{
		$this->StartQ('Database->Delete()');
		$sql = 'DELETE FROM '.$this->Prefix().$name.' WHERE '.$where;
		if($this->MySQLQuery($sql)){
			$this->Good();
			return true;
		}else{
			$this->Error('.   .');
			$this->MySQLError();
			return false;
		}
	}

	//    
	public function Select( $name, $where = '' )
	{
		$this->StartQ('Database->Select()');
		$sql = 'SELECT * FROM '.$this->Prefix().$name.($where != '' ? ' WHERE '.$where : '');
		if($this->MySQLQuery($sql)){
			$this->Good();
			return $this->SetResult($this->QueryResult);
		}else{
			$this->Error('.   .');
			$this->MySQLError();
			return false;
		}
	}

	//     
	public function NumRows()
	{
		return mysql_num_rows($this->MySQLQueryResult);
	}

	//    
	public function FetchRow()
	{
		$fet = Each($this->QueryResult);
		return $fet['1'];
	}

	//    
	public function FreeResult()
	{
		mysql_free_result($this->MySQLQueryResult);
	}

	//   
	public function GetError( $echoed = false )
	{
		if($echoed){
			echo $this->ErrorMsg;
		}
		return $this->ErrorMsg;
	}

	//  ID,    INSERT-.
	public function GetLastId()
	{
		return mysql_insert_id($this->DbAccess);
	}

	//  SQL -  mysql_query
	public function EscapeString( $UnescapedString )
	{
		return mysql_real_escape_string($UnescapedString);
	}

}
?>